//	Teeminator 1.0
//
//	Copyright (C) 2010 Paul Wilhelm <paul@mosfetkiller.de>
//	http://mosfetkiller.de/?s=teeminator

#ifndef MAIN_H_INCLUDED
#define MAIN_H_INCLUDED

//	Includes
#define F_CPU	20000000UL	//	Externer Quarz 10 MHz
#include <util/delay.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <avr/io.h>

//	Bitpopelei
#define	set_bit(var, bit)	((var) |= (1 << (bit)))
#define	clear_bit(var, bit)	((var) &= (unsigned)~(1 << (bit)))

//	Bool
#define FALSE	(0!=0)
#define TRUE	(0==0)

//	Pinout

//	Potentiometer
#define POTI_adc			0

//	Encoderausgang A
#define ENC_A_bit			1
#define ENC_A_port			PORTA
#define ENC_A_pin			PINA
#define ENC_A_ddr			DDRA

//	Encoderausgang B
#define ENC_B_bit			2
#define ENC_B_port			PORTA
#define ENC_B_pin			PINA
#define ENC_B_ddr			DDRA

//	Hauptservo
#define SERVO_MAIN_bit		3
#define SERVO_MAIN_port		PORTA
#define SERVO_MAIN_ddr		DDRA

//	Quetschservo
#define SERVO_SQUEEZE_bit	4
#define SERVO_SQUEEZE_port	PORTA
#define SERVO_SQUEEZE_ddr	DDRA

//	Würfel 1
#define DIE_1_bit			5
#define DIE_1_port			PORTA
#define DIE_1_ddr			DDRA

//	Würfel 2
#define DIE_2_bit			6
#define DIE_2_port			PORTA
#define DIE_2_ddr			DDRA

//	Würfel 3
#define DIE_3_bit			7
#define DIE_3_port			PORTA
#define DIE_3_ddr			DDRA

//	Würfel 4
#define DIE_4_bit			3
#define DIE_4_port			PORTB
#define DIE_4_ddr			DDRB

//	Taster (Encoder)
#define BUTTON_bit			0
#define BUTTON_port			PORTB
#define BUTTON_pin			PINB
#define BUTTON_ddr			DDRB

//	Poti-Stromversorgung
#define POTPWR_bit			1
#define POTPWR_port			PORTB
#define POTPWR_ddr			DDRB

//	Servo-MOSFET
#define SERVO_MOSFET_bit		2
#define SERVO_MOSFET_port		PORTB
#define SERVO_MOSFET_ddr		DDRB

//	Status-LED
#define LED_STATUS_bit		6
#define LED_STATUS_port		PORTB
#define LED_STATUS_ddr		DDRB

#endif
